package dev.shadowsoffire.apotheosis.adventure.compat;

import net.minecraft.world.entity.ai.attributes.AttributeInstance;
import snownee.jade.api.Accessor;
import java.util.stream.Stream;
import net.minecraft.world.entity.ai.attributes.AttributeModifier;
import java.util.function.Predicate;
import com.google.common.base.Predicates;
import java.util.function.Function;
import net.minecraft.world.level.Level;
import java.util.Iterator;
import net.minecraft.world.entity.ai.attributes.AttributeMap;
import net.minecraft.nbt.ListTag;
import java.util.function.Consumer;
import dev.shadowsoffire.apotheosis.util.CommonTooltipUtil;
import java.util.Objects;
import net.minecraft.resources.ResourceLocation;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraft.world.entity.ai.attributes.Attribute;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.nbt.Tag;
import snownee.jade.api.config.IPluginConfig;
import snownee.jade.api.ITooltip;
import net.minecraft.world.entity.Entity;
import snownee.jade.api.IWailaClientRegistration;
import net.minecraft.world.entity.LivingEntity;
import dev.shadowsoffire.apotheosis.Apotheosis;
import snownee.jade.api.IWailaCommonRegistration;
import snownee.jade.api.WailaPlugin;
import snownee.jade.api.EntityAccessor;
import snownee.jade.api.IServerDataProvider;
import snownee.jade.api.IEntityComponentProvider;
import snownee.jade.api.IWailaPlugin;

@WailaPlugin
public class AdventureHwylaPlugin implements IWailaPlugin, IEntityComponentProvider, IServerDataProvider<EntityAccessor>
{
    public void register(final IWailaCommonRegistration reg) {
        if (Apotheosis.enableAdventure) {
            reg.registerEntityDataProvider((IServerDataProvider)this, (Class)LivingEntity.class);
        }
    }
    
    public void registerClient(final IWailaClientRegistration reg) {
        if (Apotheosis.enableAdventure) {
            reg.registerEntityComponent((IEntityComponentProvider)this, (Class)Entity.class);
        }
    }
    
    public void appendTooltip(final ITooltip tooltip, final EntityAccessor accessor, final IPluginConfig config) {
        final Entity entity = accessor.getEntity();
        if (entity instanceof final LivingEntity living) {
            if (accessor.getServerData().m_128471_("apoth.boss")) {
                final ListTag bossAttribs = accessor.getServerData().m_128437_("apoth.modifiers", 10);
                final AttributeMap map = living.m_21204_();
                for (final Tag t : bossAttribs) {
                    final CompoundTag tag = (CompoundTag)t;
                    final Attribute attrib = (Attribute)ForgeRegistries.ATTRIBUTES.getValue(new ResourceLocation(tag.m_128461_("Name")));
                    map.m_22146_(attrib).m_22113_(tag);
                }
                accessor.getServerData().m_128473_("apoth.modifiers");
                living.getPersistentData().m_128391_(accessor.getServerData());
                final Level 9236_ = living.m_9236_();
                final LivingEntity livingEntity = living;
                Objects.requireNonNull(tooltip);
                CommonTooltipUtil.appendBossData(9236_, livingEntity, (Consumer)tooltip::add);
            }
        }
    }
    
    public void appendServerData(final CompoundTag tag, final EntityAccessor access) {
        final Entity entity = access.getEntity();
        if (entity instanceof final LivingEntity living) {
            if (living.getPersistentData().m_128471_("apoth.boss")) {
                tag.m_128379_("apoth.boss", true);
                tag.m_128359_("apoth.rarity", living.getPersistentData().m_128461_("apoth.rarity"));
                final AttributeMap map = living.m_21204_();
                final ListTag bossAttribs = new ListTag();
                final Stream stream = ForgeRegistries.ATTRIBUTES.getValues().stream();
                final AttributeMap obj = map;
                Objects.requireNonNull(obj);
                stream.map(obj::m_22146_).filter((Predicate)Predicates.notNull()).forEach(inst -> {
                    inst.m_22122_().iterator();
                    final Iterator iterator;
                    while (iterator.hasNext()) {
                        final AttributeModifier modif = iterator.next();
                        if (modif.m_22214_().startsWith("placebo_random_modifier_")) {
                            bossAttribs.add((Object)inst.m_22136_());
                        }
                    }
                    return;
                });
                tag.m_128365_("apoth.modifiers", (Tag)bossAttribs);
            }
        }
    }
    
    public ResourceLocation getUid() {
        return Apotheosis.loc("adventure");
    }
}
